<template>
  <b-container class="large-container">
    <b-card :border-variant="favorited ? 'success' : ''">
      <template #header>
        <div class="d-flex justify-content-between">
          <div class="d-flex align-items-baseline">
            <span class="mr-3">{{ locus.properties.ztf_object_id }}</span>
            <div class="d-flex text-muted mr-3 align-items-baseline">
              <coordinates-formatter-icrs
                :dec="locus.dec"
                :ra="locus.ra"
              />
            </div>
            <div class="d-flex text-muted align-items-baseline">
              <coordinates-formatter-galactic
                :l="locus.meta.coordinates.galactic.l"
                :b="locus.meta.coordinates.galactic.b"
              />
            </div>
          </div>
          <locus-actions
            :download="false"
            :locus="locus"
            @commenting="edit"
            @favorited="favorited = true"
            @unfavorited="favorited = false"
          />
        </div>
        <div class="subheader">
          <small
            v-if="comment && !editingComment"
            class="text-muted"
            @click="edit"
          >{{
            comment
          }}</small>
          <b-input
            v-if="editingComment"
            ref="commentInput"
            :disabled="submittingComment"
            :value="comment"
            class="mr-4"
            placeholder="Enter a comment for this locus"
            size="sm"
            @change="updateComment"
          />
        </div>
      </template>
      <b-card-body class="p-1">
        <b-row class="mb-3">
          <!-- the style tag on the column is there to prevent tags in locusinformation
            from going over 25% of the width -->
          <b-col style="max-width: calc(25%)">
            <b-row class="mb-2">
              <b-col>
                <locus-information :locus="locus" />
              </b-col>
            </b-row>
            <b-row class="mb-2">
              <b-col>
                <locus-plot-alert-distribution
                  :alerts="alertCandidates"
                  :locus="locus"
                />
              </b-col>
            </b-row>
            <b-row>
              <b-col>
                <aladin-viewer
                  :dec="locus.dec"
                  :ra="locus.ra"
                />
              </b-col>
            </b-row>
          </b-col>
          <b-col cols="9">
            <header-collapse
              header="Lightcurve"
              class="mb-4"
              :visible="true"
            >
              <alert-type-legend
                :locus="locus"
                :alerts="alertCandidates"
              />
              <locus-plot-lightcurve
                :locus="locus"
                :alerts="alertCandidates"
              />
            </header-collapse>

            <header-collapse
              header="Alert Thumbnails"
              class="mb-4"
              :visible="true"
            >
              <locus-alert-thumbnail-gallery-brushable :locus="locus" />
            </header-collapse>

            <header-collapse
              header="Alerts"
              :visible="true"
            >
              <locus-alert-table-brushable :locus="locus" />
            </header-collapse>
          </b-col>
        </b-row>
        <b-row>
          <b-col>
            <header-collapse
              header="Catalog Matches"
              :visible="true"
            >
              <locus-catalog-match-table
                :locus-id="locus.id"
                style="margin-bottom: 10px"
              />
            </header-collapse>
          </b-col>
        </b-row>
        <b-row>
          <b-col>
            <header-collapse
              header="Locus Properties"
              :visible="false"
            >
              <locus-properties
                :locus-properties-k-vs="locus.properties"
                :locus-id="locus.id"
              />
            </header-collapse>
          </b-col>
        </b-row>
        <b-row>
          <b-col>
            <header-collapse header="Gravitational wave events">
              <locus-grav-wave-events
                :alerts="alertCandidates"
                :locus="locus"
              />
            </header-collapse>
          </b-col>
        </b-row>
      </b-card-body>
    </b-card>
  </b-container>
</template>

<script lang="ts">
import Vue from 'vue';
import { mapGetters } from 'vuex';
import store from '@/store';
import { CREATE_OR_UPDATE_LOCUS_ANNOTATION, FETCH_LOCUS, FETCH_USER_DATA } from '@/store/actions';
import { LocusService } from '@/api';
import { Alert, LocusAnnotation } from '@/common/types';
import AladinViewer from '@/components/AladinViewer.vue';
import CoordinatesFormatterGalactic from '@/components/CoordinatesFormatterGalactic.vue';
import CoordinatesFormatterIcrs from '@/components/CoordinatesFormatterIcrs.vue';
import HeaderCollapse from '@/components/HeaderCollapse.vue';
import LocusActions from '@/components/LocusActions.vue';
import LocusAlertTableBrushable from '@/components/LocusAlertTableBrushable.vue';
import LocusAlertThumbnailGalleryBrushable from '@/components/LocusAlertThumbnailGalleryBrushable.vue';
import LocusCatalogMatchTable from '@/components/LocusCatalogMatchTable.vue';
import LocusGravWaveEvents from '@/components/Locus/GravWaveEvents.vue';
import LocusInformation from '@/components/LocusInformation.vue';
import LocusPlotAlertDistribution from '@/components/LocusPlotAlertDistribution.vue';
import LocusPlotLightcurve from '@/components/LocusPlotLightcurve.vue';
import AlertTypeLegend from '@/components/AlertTypeLegend.vue';
import LocusProperties from '@/components/LocusProperties.vue';

export default Vue.extend({
  components: {
    AladinViewer,
    AlertTypeLegend,
    CoordinatesFormatterGalactic,
    CoordinatesFormatterIcrs,
    HeaderCollapse,
    LocusActions,
    LocusAlertTableBrushable,
    LocusAlertThumbnailGalleryBrushable,
    LocusCatalogMatchTable,
    LocusGravWaveEvents,
    LocusInformation,
    LocusPlotAlertDistribution,
    LocusPlotLightcurve,
    LocusProperties,
  },

  // TODO: remove store singleton usage here since it messes up with testing.
  // Currently no tests try to enter this route, but when that eventually happens this
  // behavior can lead to unexpected results like an undesired store dispatching this action
  async beforeRouteEnter(to, from, next) {
    await store.dispatch(FETCH_LOCUS, { locusId: to.params.locusId });
    next();
  },

  data() {
    return {
      alerts: [],
      catalogMatches: [],
      editingComment: false,
      error: null,
      // Originally `favorited` was handled as a computed property. The update logic
      // broke after we moved the create/update locus annotation flow into
      // the store so the component is now responsible for tracking this state.
      favorited: false,
      loading: false,
      submittingComment: false,
    };
  },

  computed: {
    ...mapGetters(['locus', 'user', 'userData']),
    alertCandidates(): Alert[] {
      return this.alerts.filter((alert: Alert) => alert.properties.ant_survey === 1);
    },
    alertUpperLimits(): Alert[] {
      return this.alerts.filter((alert: Alert) => alert.properties.ant_survey === 2);
    },
    annotation(): LocusAnnotation | null {
      return this.userData.locusAnnotations[this.locus.id] || null;
    },
    comment(): string {
      return this.annotation ? this.annotation.comment : '';
    },
  },

  created() {
    document.title = this.locus.id;
  },

  mounted() {
    this.favorited = this.annotation ? this.annotation.favorited : false;
    this.fetchAlerts();
  },

  methods: {
    edit() {
      this.editingComment = true;
      this.$nextTick(() => (<any> this.$refs.commentInput).$el.focus());
    },

    async fetchAlerts() {
      const { data: alerts } = await LocusService.listAlerts(this.$route.params.locusId, {
        fields: { alert: 'mjd,properties,grav_wave_events' },
      });
      this.alerts = alerts;
    },

    async updateComment(comment: string) {
      this.submittingComment = true;
      try {
        await this.$store.dispatch(CREATE_OR_UPDATE_LOCUS_ANNOTATION, {
          locusId: this.locus.id,
          locusAnnotation: { comment },
        });
        await this.$store.dispatch(FETCH_USER_DATA, { identity: this.user.id });
      } finally {
        this.submittingComment = false;
        this.editingComment = false;
      }
    },
  },
});
</script>

<style>
/* This is a global style that's applied to the whole application
 * TODO: move this to a global file or use scoped styles since we should avoid global
 * rules inside a specific component (it can lead to unpredictable rules applied)
 */
h1 {
  font-size: 1.2em;
}
</style>
